<template>
  <div class="app-container">
    <el-form ref="postForm" :rules="formRules" :model="formData" label-width="150px">
      <el-form-item label="调度员名称：" prop="yardman_name">
        <el-col :span="6">
          <el-input v-model="formData.yardman_name" placeholder="请输入调度员名称"/>
        </el-col>
      </el-form-item>
      <el-form-item label="登录账号：" prop="account">
        <el-col :span="6">
          <el-input v-model="formData.account" placeholder="请输入登录账号"/>
        </el-col>
      </el-form-item>
      <el-form-item label="性别：" prop="yardman_gender">
        <el-col :span="6">
          <el-select v-model="formData.yardman_gender" placeholder="请选择" clearable>
            <el-option label="男" :value="1" ></el-option>
            <el-option label="女" :value="2" ></el-option>
          </el-select>
        </el-col>
      </el-form-item>
      <el-form-item label="联系电话：" prop="yardman_phone">
        <el-col :span="6">
          <el-input v-model="formData.yardman_phone" placeholder="请输入联系电话"/>
        </el-col>
      </el-form-item>
      <el-form-item label="登录密码：" prop="password">
        <el-col class="flex" :span="6">
          <el-input :disabled="!passwordValue" v-model="formData.password" placeholder="请输入登录密码"/>
          <el-switch class="ml-10 mt-10" v-if="$props.id" v-model="passwordValue" active-color="#13ce66" inactive-color="#ff4949"></el-switch>
        </el-col>
      </el-form-item>
      <el-form-item label="账户状态：" prop="freeze_flag">
        <el-col :span="6">
          <el-select v-model="formData.freeze_flag" placeholder="请选择" clearable>
            <el-option label="正常" :value="false" ></el-option>
            <el-option label="冻结" :value="true" ></el-option>
          </el-select>
        </el-col>
      </el-form-item>
      <el-form-item align="center">
        <el-button type="primary" @click="submitForm">保存</el-button>
        <el-button @click="onCancel">取消</el-button>
      </el-form-item>
    </el-form>
  </div>
</template>

<script>
import { checkRqInput, checkPwdLength, checkTel } from '@/utils/validate'
import { detailYardman, updateYardman, createYardman,  } from '@/api/user/index'

export default {
  name: 'ArticleDetail',
  // 配合路由配置的props属性实现在组件中通过props获取参数
  props: {
    id: {
      type: String,
      default() {
        return this.$route.params.id;
      }
    }
  },
  data() {
    return {
      formData: {freeze_flag:false},
      // 校验规则
      formRules: {
        yardman_name: [ checkRqInput ],
        account: [ checkRqInput ],
        yardman_gender: [ checkRqInput ],
        yardman_phone: [ checkRqInput, checkTel ],
        password: [ checkRqInput, checkPwdLength ],
        freeze_flag: [ checkRqInput ]
      },
      passwordValue: this.$props.id?false:true, // 密码按钮状态
    }
  },
  created() {
    this.fetchDetail()
  },
  methods: {
    // 获取企业详情
    fetchDetail() {
      const id = this.$props.id
      if (id) {
        this.$http(detailYardman(id), (res) => {
          if (res.code == 0) {
            this.formData = res.data
          }
        })
      }
      this.formData.yardman_id = id
    },
    // 提交表单
    submitForm() {
      this.$refs['postForm'].validate((valid) => {
        if (valid) {
          // 修改
          if (this.formData.yardman_id) {
            this.$http(updateYardman(this.formData), res => {
              this.$message({
                message: '成功',
                type: 'success'
              })
              this.$router.go(-1)
            })
          } else {
            // 新增
            this.$http(createYardman(this.formData), res => {
              this.$message({
                message: '成功',
                type: 'success'
              })
              this.$router.go(-1)
            })
          }
        } else {
          return false
        }
      })
    },
    // 取消
    onCancel() {
      this.$message({
        message: '已取消!',
        type: 'warning'
      })
      this.$router.go(-1)
    },
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
</style>
